#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bmsg.h"
#include "fullempty_server.h"

#include "config.h"
#include "reduce_server.h"

/* Map the nodeval' variable to emptyfree id 1...t: */
#define NODEVAL(i) ((i) + 1)

static tally_t localTally(int size, data_t *myArray);

int main(int argc, char **argv)
{
  struct connection_t *c;
  int t, nums[3], n, index;
  char msg[4];
  data_t *myArray;

  do {
    c = wait_for_connection(argv[1]);

    recv_byte_message(c, sizeof(nums), nums);
    index = nums[0];
    t = nums[1];
    n = nums[2];

    printf("Connected as %d of %d; %d elements\n", index, t, n);

    myArray = (data_t *)malloc(n * sizeof(data_t));
    
    recv_byte_message(c, n * sizeof(data_t), myArray);

    {
      tally_t tally, child_tally;
      int stride;
      
      tally = localTally(n, myArray);
      
      for (stride = 1; stride < t; stride *= 2) {
        if (index % (2 * stride) == 0) {
          fullempty_get(c, NODEVAL(index + stride), sizeof(tally_t), &child_tally);
          tally = combine(tally, child_tally);
        } else {
          fullempty_put(c, NODEVAL(index), sizeof(tally_t), &tally);
          break;
        }
      }
    
      if (index == 0)  {
        result_t result;
        result = reduceGen(tally);
        fullempty_put(c, 0, sizeof(result), &result); /* filling fullempty id "0" means we're done */
      }
    }

    /* wait for done message: */
    recv_byte_message(c, 4, msg);
    if (memcmp(msg, "done", 4)) {
      printf("didn't receive expected \"done\" message\n");
      abort();
    }

    close_connection(c);

    free(myArray);

    printf("Done\n");
  } while (0);  /* <- change 0 to 1 to loop */

  return 0;
}

tally_t localTally(int size, data_t *myArray)
{
  int i;
  tally_t tally = init();
 
  for (i = 0; i < size; i++)
   tally = accum(tally, i, myArray);

  return tally;
}
